-module(gagenome).
-export([random_any/0, random_terminal/0, random_individual/1, 
         random_population/2, arity/1]).

%
% code for the genome of basic arithmetic expressions that can be
% composed of +,-,/,*,sqrt, and two variables a and b.
%
% Matthew Sottile / matt@cs.uoregon.edu
%

% determine the arity of a character
arity(X) ->
  case X of
    q -> 1;
    plus -> 2;
    minus -> 2;
    times -> 2;
    divide -> 2;
    a -> 0
%    b -> 0
  end.

% generate a random gene character from the set of terminals and
% non-terminals
random_any() ->
  N = random:uniform(6),
  case N of
    1 -> plus;
    2 -> minus;
    3 -> divide;
    4 -> times;
    5 -> q;
    6 -> a
%    7 -> b
  end.
  
% generate a random terminal
%random_terminal() ->
%  N = random:uniform(2),
%  case N of
%    1 -> a;
%    2 -> b
%  end.

random_terminal() -> a.
  
random_gene(_,0) -> [];
random_gene(TailLen,N) ->
  if 
    (N > TailLen) -> [random_any()]++(random_gene(TailLen,N-1));
    true -> [random_terminal()]++(random_gene(TailLen,N-1))
  end.

% generate a random individual, hardcoded max arity of 2
random_individual(HeadLen) ->
  MaxArity = 2,
  GeneLen = HeadLen + ((HeadLen*(MaxArity-1)) + 1),
  random_gene(GeneLen-HeadLen,GeneLen).
  
random_population(0, _) -> [];
random_population(N, HeadLen) ->
  [random_individual(HeadLen)]++(random_population(N-1,HeadLen)).
